/****************************************************************************
 *   RgbwPacketDecoder.cpp by (c) 2018 Marcio Teixeira                      *
 *                                                                          *
 *   This program is free software: you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation, either version 3 of the License, or      *
 *   (at your option) any later version.                                    *
 *                                                                          *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for more details.                           *
 *                                                                          *
 *   To view a copy of the GNU General Public License, go to the following  *
 *   location: <http://www.gnu.org/licenses/>.                              *
 ****************************************************************************/

#include "RgbwPacketDecoder.h"

void RgbwPacketDecoder::decode(uint8_t const* packet, size_t length) {
  button     = packet[5];
  
  const uint8_t raw_hue        = packet[3];
  const uint8_t raw_brightness = packet[4];
  
  if (raw_brightness <= 160)
    brightness = map(raw_brightness,   0, 160, 128, 0);
  if (raw_brightness >= 184)
    brightness = map(raw_brightness, 248, 184, 128, 255);
  
  hue = raw_hue + 226;
}